<template>
  <div>
    <div v-if="room">
      <banner
        :title="room.name"
        :link="'/rooms/'"
        :linkText="'back to room'"
        :style="{
          'background': 'url(http://localhost:4141/' + room.images[0] + ') center/cover no-repeat',
        }"
      ></banner>
      <div class="room-about">
        <div class="room-about__img" v-if="room.images.length > 0">
          <img
            v-for="(image, index) in room.images"
            :key="index"
            :src="'http://localhost:4141/' + image"
            :alt="room.name"
          />
        </div>
        <div class="room-about-body">
          <div class="room-about-body__detail">
            <h3>details</h3>
            <p>{{ room.description }}</p>
          </div>
          <div class="room-about-body__info">
            <h3>Info</h3>
            <ul class="room-about-body-info__list">
              <li>Price: ${{ room.price }}</li>
              <li>Size: {{ room.size }}SQFT</li>
              <li>
                Max Capacity:
                {{
                  room.capacity > 1
                    ? `${room.capacity} people`
                    : `${room.capacity} person`
                }}
              </li>
              <li>{{ room.pets ? "pets allowed" : "no pets allowed" }}</li>
              <li>
                {{
                  room.breakfast ? "free breakfast included" : "No breakfast"
                }}
              </li>
            </ul>
          </div>
        </div>
        <div class="room-about-extras">
          <h4>Extras</h4>
          <ul class="room-about-extras__list">
            <li v-for="(extra, index) in room.extras" :key="index">
              {{ extra }}
            </li>
          </ul>
        </div>
      </div>
    </div>
    <div v-else>
      <p>Nothing to display</p>
    </div>
  </div>
</template>

<script>
import Banner from "./Banner";
import { formatData } from "./../helper";
export default {
  components: {
    banner: Banner,
  },
  props: {
    roomId: {
      required: true,
    },
  },
  data() {
    return {
      room: null,
    };
  },
  created() {
    const roomId = this.$route.params.roomId;
    this.getProduct(roomId).then((room) => (this.room = formatData(room)));
  },
  methods: {
    getProduct(roomId) {
      return this.$http
        .get("http://localhost:4141/rooms/{roomId}", {
          params: {
            roomId: roomId,
          },
        })
        .then(
          (response) => response.json(),
          (response) => alert("Could not retrieve product!")
        );
    },
  },
};
</script>

<style lang="">
.room-about {
  padding: 5rem 0 0 0;
}

.room-about__img {
  width: 80vw;
  margin: 0 auto;
  display: grid;
  grid-template-columns: repeat(auto-fit, minmax(350px, 1fr));
  grid-row-gap: 2rem;
  grid-column-gap: 50px;
}

.room-about__img img {
  width: 100%;
  display: block;
}

.room-about-body {
  width: 80vw;
  display: grid;
  grid-template-columns: 1fr;
  margin: 2rem auto;
}

.room-about-body__detail,
.room-about-body__info {
  margin: 1rem 0;
}

.room-about-body__detail h3 {
  text-transform: capitalize;
  letter-spacing: var(--mainSpacing);
}

.room-about-body-info__list {
  list-style: none;
  text-transform: capitalize;
  font-size: 1em;
}

.room-about-body-info__list li {
  letter-spacing: var(--mainSpacing);
  margin-bottom: 1.5em;
}

.room-about-extras {
  width: 80vw;
  margin: 0 auto 3rem auto;
}

.room-about-extras__list {
  list-style-type: none;
  display: grid;
  grid-template-columns: repeat(auto-fit, minmax(330px, 1fr));
  grid-column-gap: 2rem;
  grid-row-gap: 1rem;
}

@media screen and (min-width: 992px) {
  .room-about__img {
    width: 95vw;
    max-width: 1170px;
  }

  .room-about-body {
    width: 95vw;
    max-width: 1170px;
    grid-template-columns: 1fr 1fr;
    grid-column-gap: 2rem;
  }

  .room-about-body__info {
    padding-left: 3rem;
  }

  .room-about-extras {
    width: 95vw;
    max-width: 1170px;
  }
}
</style>
